public class Form {

    private LinkedList<Verbindung> verbindungen = new LinkedList<Verbindung>();
    private LinkedList<Verbindung> uV = new LinkedList<Verbindung>();//unvollständige Verbindungen
    private LinkedList<Verbindung> kV = new LinkedList<Verbindung>();//komplette Verbindungen
    private LinkedList<Verbindung> quadrate =  new LinkedList<Verbindung>();//ist keine Teilmege von Quader
    private LinkedList<Verbindung> quader =  new LinkedList<Verbindung>();//Quader mit einem maximalen Seitenverhältnis von 4 zu 1(ausgenommen Quadrate)
    private LinkedList<Verbindung> dreiecke = new LinkedList<Verbindung>();//Gleichseitige Dreiecke
    private LinkedList<Verbindung> achtecke = new LinkedList<Verbindung>();//Gleichmäßiges Achteck
    private LinkedList<Verbindung> grossePolygone = new LinkedList<Verbindung>();//Polygone mit mehr als 8 Ecken

    private float spielraum = 0.1f;
    private boolean istVerbunden = false;

    public Form() {
    }
    public LinkedList<Verbindung> copy(LinkedList<Verbindung> original){
        LinkedList<Verbindung> ver = new LinkedList<Verbindung>();
        for (int i = 0; i<original.size();i++){
            Verbindung kopie = original.get(i).copy();
            ver.add(kopie);
        }
        return ver;
    }
    public LinkedList<Verbindung> getUV() {
        aufteilen();
        return copy(uV);
    }
    public LinkedList<Verbindung> getKV() {
        aufteilen();
        return copy(kV);
    }
    public LinkedList<Verbindung> getDreiecke() {
        aufteilen();
        return copy(dreiecke);
    }
    public LinkedList<Verbindung> getQuader() {
        aufteilen();
        return copy(quader);
    }
    public LinkedList<Verbindung> getQuadrate() {
        aufteilen();
        return copy(quadrate);
    }
    public LinkedList<Verbindung> getAchtecke() {
        aufteilen();
        return copy(achtecke);
    }
    public LinkedList<Verbindung> getGrossePolygone() {
        aufteilen();
        return copy(grossePolygone);
    }
    public void addLine(Line l) {
        boolean hinzu = false;
        for (int i = 0; i<verbindungen.size(); i++) {
            boolean h = verbindungen.get(i).addLine(l);
            if (h){
                hinzu = true;
                break;
            }
        }
        if (hinzu == false) {
            Verbindung v = new Verbindung();
            v.addLine(l);
            verbindungen.add(v);
        }
    }
    private void aufteilen() {//teilt verbindungen in uV und kV auf
        if (istVerbunden == false) {
            if (uV.isEmpty() && kV.isEmpty()) {
                for (int i = 0; i < verbindungen.size(); i++) {
                    Verbindung v = verbindungen.get(i);
                    if (v.fullyConnected) kV.add(v);
                    else uV.add(v);
                }
            }
            boolean zusammenfuegen = true;
            while (zusammenfuegen) zusammenfuegen = fusionieren();
            ermittleFormen();
            istVerbunden = true;
        }
    }
    private boolean fusionieren() {//fügt unvollständige Formen zusammen
        LinkedList<Verbindung> uv1 = copy(uV);
        LinkedList<Verbindung> uv2 = copy(uV);
        int a = 0;
        while(uv1.size()>a) {
            int b = 0;
            Verbindung v1 = uv1.get(a).copy();
            while(uv2.size()>b) {
                Verbindung v2 = uv2.get(b).copy();
                LinkedList<Line> f = v2.getForm();
                if (a!=b) {
                    boolean passt = false;
                    passt = v1.addLine(f.get(0));
                    if (passt == true) for (int c = 1; c<f.size(); c++)v1.addLine(f.get(c));
                     else {
                        passt = v1.addLine(f.get(f.size()-1));
                        if (passt == true) for (int c = f.size()-2; c>0; c--) v1.addLine(f.get(c));
                    }
                    if (passt == true) {
                        uV.remove(b);
                        if(b<a)a--;//Wenn b vor a ist, verschiebt sich der Index
                        uV.remove(a);
                        if (v1.fullyConnected)kV.add(v1);
                        else uV.add(v1);
                        return true;
                    }
                }
                b++;
            }
            a++;
        }
        return false;
    }

    private void addQuader(Verbindung v) {//Ermittelt Quader, die ein gewisses Seitenverhältnis haben
        if (v.anzahlPunkte() == 4) {
            LinkedList<Float> l = v.getLaengen();
            float verhaeltnis = 8;
            if (l.get(0) >= l.get(2)*(1-spielraum) && l.get(0)<= l.get(2)*(1+spielraum)) {
                if (l.get(1) >= l.get(3)*(1-spielraum) && l.get(1)<= l.get(3)*(1+spielraum)) {
                    if(!(l.get(1) >= l.get(2)*(1-spielraum) && l.get(1)<= l.get(2)*(1+spielraum))) {//kein Quadrat!
                        if (l.get(0) <= l.get(1) * verhaeltnis || l.get(1) <= l.get(1) * verhaeltnis) quader.add(v.copy());
                    }
                }
            }
        }
    }
    private void addDreieck(Verbindung v) {//Fügt Dreiecke hinzu
        if (v.anzahlPunkte() == 3) {
            LinkedList<Float> l = v.getLaengen();
            if (l.get(0) >= l.get(2)*(1-spielraum) && l.get(0)<= l.get(2)*(1+spielraum)) {
                if (l.get(1) >= l.get(2)*(1-spielraum) && l.get(1)<= l.get(2)*(1+spielraum)) {
                    dreiecke.add(v.copy());
                }
            }
        }
    }
    private void addAchteck(Verbindung v){
        if (v.anzahlPunkte() == 8){
            LinkedList<Float> l = v.getLaengen();
            boolean istAchteck = true;
            for (int i = 0; i<l.size()-1;i++){
                if (!(l.get(i) >= l.get(i+1)*(1-spielraum) && l.get(i)<= l.get(i+1)*(1+spielraum)))istAchteck = false;
            }
            if (istAchteck) achtecke.add(v.copy());
        }
    }
    private void addQuadrate(Verbindung v){
        //überprüft das Seitenverhältnis, ob ein Quadrat in Frage kommt
        if (v.anzahlPunkte() == 4){
            LinkedList<Float> l = v.getLaengen();
            boolean istQuadrat = true;
            for (int i = 0; i<l.size()-1;i++){
                if (!(l.get(i) >= l.get(i+1)*(1-spielraum) && l.get(i)<= l.get(i+1)*(1+spielraum)))istQuadrat = false;
            }
            if (istQuadrat) quadrate.add(v.copy());
        }
    }
    private void addPolygon(Verbindung v){
        if (v.anzahlPunkte() > 8)grossePolygone.add(v.copy());
    }
    private void ermittleFormen(){//ermittelt verschiedene Formen
        LinkedList<Verbindung> polygone = copy(kV);
        for (int i = 0; i<polygone.size();i++){
            addDreieck(polygone.get(i).copy());
            addQuadrate(polygone.get(i).copy());
            addQuader(polygone.get(i).copy());
            addAchteck(polygone.get(i).copy());
            addPolygon(polygone.get(i).copy());
        }
    }
}
